import java.text.*

class Main {

    static Coligacao ContensColigacao(LinkedList<Coligacao> lista, Coligacao c){
        for(Coligacao h: lista){
            if(h.getNome() == c.getNome()){
                return 	h
            }
        }
        return null
    }
    static Partido ContensPartido(LinkedList<Partido> lista, Partido p){
        for(Partido h: lista){
            if(h.getNome() == p.getNome()){
                return 	h
            }
        }
        return null
    }

    static void main(String[] args) throws FileNotFoundException {

        LinkedList<Partido> partidos = new LinkedList<Partido>()
        LinkedList<Candidato> candidatos = new LinkedList<Candidato>()
        LinkedList<Coligacao> coligacoes = new LinkedList<Coligacao>()

        NumberFormat nf = NumberFormat.getInstance(Locale.forLanguageTag("pt-br"))

        Number n = null
        String porcentagem=" "
        int numero=0,numVagas=0
        int numVotos=0

        String seq="",nome=""
        String linhasDoArquivo = new String()
        Partido p
        Coligacao c

        File Eleicoes2016 = new File("./src/vitoria2016.csv")
        Scanner leitor = new Scanner(Eleicoes2016)


        leitor.nextLine()
        //leitura das linhas do arquivo
        while(leitor.hasNext()){
            boolean eleito=false
            linhasDoArquivo = leitor.nextLine()
            String[] campos = linhasDoArquivo.split(";") //divisão dos campos entre ponto e virgula
            if(!campos[0].isEmpty()){
                seq = campos[0]
                if(seq.charAt(0)== ('*' as char)){
                    eleito = true
                    numVagas++
                }
            }
            if(!campos[1].isEmpty()){
                numero = Integer.parseInt(campos[1])
            }
            if(!campos[2].isEmpty()){
                nome = campos[2]
            }

            String[] s = campos[3].split("-")
            if(!campos[4].isEmpty()){
                try {
                    n=nf.parse(campos[4])
                } catch (ParseException e) {
                    e.printStackTrace()
                }

            }
            numVotos = n.intValue()
            if(!campos[5].isEmpty()){
                porcentagem = campos[5]
            }

            if(s.length > 1){
                c = new Coligacao(s[1])
                p = new Partido(s[0],c)
            }else{
                c = new Coligacao(s[0])
                p = new Partido(s[0],c)
            }
            Candidato candidato = new Candidato(nome,numero,numVotos,eleito,p,c)
            candidatos.add(candidato)
            if(coligacoes.size()>0){
                if(ContensColigacao(coligacoes,c)==null){
                    p.addCandidato(candidato)
                    c.addPartido(p)
                    coligacoes.add(c)
                    partidos.add(p)
                }else{
                    if(ContensPartido(ContensColigacao(coligacoes,c).getPartidos(),p)==null){
                        p.addCandidato(candidato)
                        ContensColigacao(coligacoes,c).addPartido(p)
                        partidos.add(p)
                    }else{
                        ContensPartido(ContensColigacao(coligacoes,c).getPartidos(),p).addCandidato(candidato)
                    }

                }
            }else{
                p.addCandidato(candidato)
                c.addPartido(p)
                coligacoes.add(c)
                partidos.add(p)
            }

        }
        Impressor imp = new Impressor ()

        imp.numVag(numVagas)
        imp.verEleitos(candidatos)
        imp.candMaisVotados(numVagas,candidatos)
        imp.candPrejudicadoseBeneficiados(numVagas,candidatos)
        imp.votColigacoes(coligacoes)
        imp.votPartidos(partidos)
        imp.totVotos(candidatos)

        leitor.close()
    }
}
